from jsonpickle import encode
from flask import Flask
from flask import abort, redirect, url_for
from flask import request
from flask import render_template
from flask import session
from flask import jsonify
from book import Book
import logging
from bookdao import BookDao
from book import Book
from userdao import UserDao
from user import User

app = Flask(__name__)

@app.route('/')
def index():
    return redirect(url_for('login'))

@app.route('/login', methods=['POST', 'GET'])
def login():
    error = None

    if ('userid' in request.form):
        if isValid(request.form['userid'],request.form['password']):
            return render_template('survey.html', **locals())
        else:
            error = 'Invalid userid/password'

    # the code below is executed if userid not found in form
    return render_template('login.html', **locals())


def isValid(userid, password):
    dao = UserDao()
    user = dao.selectByUserid(userid)
    
    if (user is not None) and (userid == user.userid) and (password == user.password):
        session['user']=encode(user) # use an encoder to convert user to a JSON object for session
        return True
    else:
        return False

@app.route('/ajax_getbooks', methods=['POST', 'GET'])
def ajax_getbooks():
    error = None

    dao = BookDao()
    books = dao.selectAll()
    serialized_books = [book.serialize() for book in books]

    return jsonify(serialized_books);

@app.route('/ajax_sendvote', methods=['POST', 'GET'])
def ajax_sendvote():
    error = None

    isbn = request.args.get('isbn')
    dao = BookDao()
    book = dao.selectByISBN(isbn)
    book.votes = book.votes + 1
    dao.update(book)

    return jsonify(book.serialize());

if __name__ == "__main__":
    app.secret_key = 'A0Zr98j/3yX R~XHH!jmN]LWX/,?RT'
    app.run(host='0.0.0.0', port=8000, threaded=True, debug=True)
